local image, shader, GW, GH, GOX, GOY, cannon

function love.load()

    love.window.setMode(960, 540)

    shader = love.graphics.newShader("shader.frag")
    image = love.graphics.newImage("image.png")

    GW, GH = love.graphics.getDimensions()
    GOX, GOY = GW*.5, GH*.5

    cannon = {
        cx = GOX,
        cy = GH*.9,
        r = 0
    }

    love.graphics.setLineWidth(16)
    shader:send("thickness", 16)

end


function love.update(dt)

    local mx, my = love.mouse.getPosition()

    cannon.r = -math.atan2(
        -(my-cannon.cy),
        mx-cannon.cx
    )

    shader:send("p1", {
        cannon.cx+math.cos(cannon.r)*32,
        cannon.cy+math.sin(cannon.r)*32
    })

    shader:send("p2", {mx, my})
    shader:send("time", 3*love.timer.getTime())

end

function love.draw()

    love.graphics.setShader(shader)
    love.graphics.draw(image,0,0,0,.5)
    love.graphics.setShader()

    love.graphics.setColor(0,0,0)

    love.graphics.circle(
        "fill",cannon.cx, cannon.cy, 16
    )

    love.graphics.line(
        cannon.cx, cannon.cy,
        cannon.cx+math.cos(cannon.r)*32,
        cannon.cy+math.sin(cannon.r)*32
    )

    love.graphics.setColor(1,1,1)


end


